Bug 859052 - Sendmail doesn't support dual-stack IPv4/IPv6 with static addresses: "too many daemons defined"
Sendmail doesn't support dual-stack IPv4/IPv6 with static addresses: "too man...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: sendmail (Show other bugs)
17
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Jaroslav Škarvada
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-20 09:10 EDT by tlhackque
Modified: 2013-07-31 21:53 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-31 21:53:52 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description tlhackque 2012-09-20 09:10:41 EDT
Description of problem:

Sendmail refuses to start when a server with both static IPv4 and IPv6 addresses is configured with an MSA, MTA & TLS.

Version-Release number of selected component (if applicable):

sendmail.x86_64                         8.14.5-14.fc17               @updates

How reproducible:

Configure sendmail as follows (substitute your own addresses for the doc addresses used below!):

DAEMON_OPTIONS(`Port=smtp,Addr=127.0.0.1, Name=MTA')dnl
DAEMON_OPTIONS(`Port=smtp,Addr=192.0.2.1, Name=MTA4')dnl
DAEMON_OPTIONS(`Port=smtp,Addr=::1, Family=inet6, Name=MTA6')dnl
DAEMON_OPTIONS(`Port=smtp,Addr=2001:2001:DB8::19, Family=inet6, Name=MTA6')dnl
DAEMON_OPTIONS(`Port=submission, Name=MSA, M=Ea')dnl
DAEMON_OPTIONS(`Port=submission,Addr=192.0.2.1, Name=MSA4, M=Ea')dnl
DAEMON_OPTIONS(`Port=submission,Addr=::1, Family=inet6, Name=MSA6, M=Ea')dnl
DAEMON_OPTIONS(`Port=submission,Addr=2001:DB8::19, Family=inet6, Name=MSA6, M=Ea')dnl

DAEMON_OPTIONS(`Port=smtps,Addr=127.0.0.1, Name=TLSMTA, M=s')dnl
DAEMON_OPTIONS(`Port=smtps,Addr=192.0.2.1, Name=TLSMTA4, M=s')dnl
DAEMON_OPTIONS(`Port=smtps,Addr=::1, Family=inet6, Name=TLSMTA6, M=s')dnl
DAEMON_OPTIONS(`Port=smtps,Addr=2001:DB8::19, Family=inet6, Name=TLSMTA6, M=s')dnl

Fails with:
sendmail[2985]: 554 5.0.0 /etc/mail/sendmail.cf: line 287: too many daemons defined (10 max)
sendmail[2985]: 554 5.0.0 /etc/mail/sendmail.cf: line 288: too many daemons defined (10 max)
sendmail[2985]: NOQUEUE: SYSERR(root): /etc/mail/sendmail.cf: line 287: too many dae... max)
sendmail[2985]: NOQUEUE: SYSERR(root): /etc/mail/sendmail.cf: line 288: too many dae... max)

The problem is that the (hardcoded constant) MAXDAEMONS in sendmail/conf.h is 10

But this (reasonable) configuration requires 12 daemons:  (MSA+MTA+TLS) * (LoopV4+LoopV6+WanV4+WanV6) = 3 * 4 = 12!

This parameter controls a few smallish tables.  Since one might imagine a site with more than one attached network, a value of 25 seems more reasonable.

The following patch accomplishes this.  I suggest also sending it upstream since IPV6 is (finally) gathering some momentum!

Additional info:

You won't notice this if you listen on the wildcard IP addresses as many people do, or if you only run 2 of the three daemon classes...

cat sendmail_maxDaemons.patch
--- sendmail/conf.h.orig        2012-09-20 08:27:18.000000000 -0400
+++ sendmail/conf.h     2012-09-20 08:28:00.000000000 -0400
@@ -110,11 +110,11 @@
 #define MAXMACROID     0377            /* max macro id number */
                                        /* Must match (BITMAPBITS - 1) */
 #ifndef MAXHDRSLEN
 # define MAXHDRSLEN    (32 * 1024)     /* max size of message headers */
 #endif /* ! MAXHDRSLEN */
-#define MAXDAEMONS     10              /* max number of ports to listen to */
+#define MAXDAEMONS     25              /* max number of ports to listen to */
 #ifndef MAXINTERFACES
 # define MAXINTERFACES 512             /* number of interfaces to probe */
 #endif /* MAXINTERFACES */
 #ifndef MAXSYMLINKS
 # define MAXSYMLINKS   32              /* max number of symlinks in a path */
Comment 1 Fedora End Of Life 2013-07-03 19:18:44 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 2 Fedora End Of Life 2013-07-31 21:53:58 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.